# Spec Input StreamIterator
Iter specialiazion for reading from streams.

Extends | StreamIterator
All Extended | Iter, StreamIterator
All Impl'd | IteratorAssociatedTypesConcept
Defined in |
Signature | `template <typename TStream> class Iter<TStream, StreamIterator<Input> >;`

## Template Parameters

`TStream` | The StreamConcept to iterate over.

## Member Function Overview

- `Iter::Iter();, Iter::Iter(stream);, Iter::Iter(streamBuffer);`
  The constructors.

### Member Functions Inherited From Iter

- `Iter`

## Interface Function Overview

### Interface Functions Inherited From StreamIterator

- `reserveChunk`

### Interface Functions Inherited From IteratorAssociatedTypesConcept

- `operator*`
- `value`
- `getValue`

## Interface Metafunction Overview

### Interface Metafunctions Inherited From Iter

- `Container`
- `IterComplementConst`
- `IterMakeConst`
- `Spec`

### Interface Metafunctions Inherited From IteratorAssociatedTypesConcept

- `Difference`
- `GetValue`
- `Pointer`
- `Reference`
- `Value`

## Member Functions Detail

### `Iter::Iter(); Iter::Iter(stream); Iter::Iter(streamBuffer);`

The constructors.

#### Parameters

`stream` | The `TStream` to read from.
`streamBuf` | A StreamBuffer to read from.

Allows default construction, construction from stream, as well as from a StreamBuffer.

#### Data Races

If not stated otherwise, concurrent invocation is not guaranteed to be thread-safe.

#### Dox Sources

    /*!
     * @class InputStreamIterator Input StreamIterator
     *
     * @extends StreamIterator
     *
     * @brief @link Iter @endlink specialiazion for reading from @link StreamConcept
     *        streams @endlink.
     *
     * @signature template <typename TStream> class Iter<TStream,
     *            StreamIterator<Input> >;
     *
     * @tparam TStream The @link StreamConcept @endlink to iterate over.
     *
     * @fn InputStreamIterator::Iter
     *
     * @brief The constructors.
     *
     * @signature Iter::Iter();
     * @signature Iter::Iter(stream);
     * @signature Iter::Iter(streamBuffer);
     *
     * @param[in] stream The <tt>TStream</tt> to read from.
     * @param[in] streamBuf A @link StreamBuffer @endlink to read from.
     *
     * Allows default construction, construction from stream, as well as from a
     * @link StreamBuffer @endlink.
     */